function estimate_velocity( data, frequency )
  % Estimate sign of velocity based on model.

% stuff
Ts = 0.005;
% compute period in samples
period = 1/(Ts*frequency);
filter_cutoff = 0.1;

a = 0.9325;
b = 0.0045;
k = 1;   % just fixes sign, noise filterg
k = 0.01; % very smooth
k = 0.1; % discrete intervals show through a little bit

N = length( data );
abs_encoder = data(:,2);
commands = data(:,3);
increments( N ) = 0;
new_velocities( N ) = 0;

increments(1) = abs_encoder(2) - abs_encoder(1);
% increments(1) = 0;
if ( commands( 1 ) >= 0 )
  new_velocity( 1 ) = increments( 1 );
else
  new_velocity( 1 ) = -increments( 1 );
end

for i = 2:N
  prediction = a*new_velocity(i-1) + b*commands(i-1);
  increments(i) = abs_encoder(i) - abs_encoder(i-1);
  if ( prediction >= 0 )
    measured = increments(i);
  else
    measured = - increments(i);
  end
  new_velocity(i) = prediction + k*(measured - prediction);
end

figure(1);
plot( data(:,4)/1000, 'b' );
hold
plot( new_velocity, 'r' );
hold

start = 20;
n_points = 2*period;
if n_points > N - start - 1;
   n_points = N - start - 1;
end

figure(2);
plot( new_velocity(start:round(start+n_points-1)));

[b,a] = butter(1,filter_cutoff);

figure(3);
plot( increments(start:round(start+n_points-1)), 'b');
hold
plot( abs(new_velocity(start:round(start+n_points-1))), 'r');
% plot( filtfilt(b,a,abs(new_velocity(start:round(start+n_points-1)))));
hold

pause(5);
end
