function [gain phase] = find_gain_phase_vel( data, frequency, filter_cutoff )
  % find the gain and phase relationship of command (3) and velocity (4)

% stuff
Ts = 0.005;

velocity = data(:,4)/1000;
commands = data(:,3);
N = length(velocity);

% compute period in samples
period = 1/(Ts*frequency);

% check out fits over an entire period.

start = 1;
n_points = N;
min_score = 1e10;
max_shift = period/2;

for i = 1:max_shift;
  [p,conf_intervals,residuals] = regress(velocity(start:(start+n_points-1)),commands(1:n_points));
  score = 0;
  for j = 1:n_points
    score = score + residuals(j)*residuals(j);
  end
  score = score/length(residuals);
  if score < min_score
    min_score = score;
    min_i = i;
    min_p = p;
  end
  start = start+1;
  n_points = n_points-1;
end

gain = min_p;
phase = min_i/period;
[frequency gain phase]

start = 20;
n_points = 5*period;
if n_points > N - min_i - start
   n_points = N - min_i - start;
end

figure(1);
plot( commands(start:round(start+n_points-1)), 'b' );
hold;
plot( velocity(start+min_i-1:round(start+min_i+n_points-2))/gain, 'r' );
hold;

%pause(5);
