function [gain phase] = model_bode( frequency, p, delay )
  % find the gain and phase relationship of a simulated command and a simulated velocity. p is the parameter vector.

% constants
Ts = 0.005;
% compute period in samples
period = 1/(Ts*frequency);
N = round(10*period);
min_p = 0; % wierd matlab bug
min_i = 0; % wierd matlab bug

% allocate these arrays
commands(N) = 0;
velocities(N) = 0;

% generate commands
for i = 1:N
  commands(i) = sin( i*Ts*frequency*2*pi ); % command magnitude doesn't matter
end

% apply parameters
a = [ p(2) ];
b = [ p(1) ];

velocities(1) = 0;
for i = 2:N
    velocities(i) = a*velocities(i-1) + b*commands(i-1);
end

% compute period in samples
period = 1/(Ts*frequency);

start = 1;
n_points = N;
min_score = 1e10;
max_shift = period/2;

for i = 1:max_shift;
[p,conf_intervals,residuals] = regress(transpose(velocities(start:(start+n_points-1))),transpose(commands(1:n_points)));
  score = 0;
  for j = 1:n_points
    score = score + residuals(j)*residuals(j);
  end
  score = score/length(residuals);
  if score < min_score
    min_score = score;
    min_i = i;
    min_p = p;
  end
  start = start+1;
  n_points = n_points-1;
end

gain = min_p;
phase = min_i/period;
% [frequency gain phase]

start = 20;


if ( delay > 0 )
  n_points = 5*period;
  if n_points > N - min_i - start
     n_points = N - min_i - start;
  end
  figure(1);
  plot( commands(start:round(start+n_points-1)), 'b' );
  hold;
  plot( velocities(start+min_i-1:round(start+min_i+n_points-2))/gain, 'r' );
  hold;
  pause( delay );
end
end
